%{!?python_sitearch: %global python_sitearch %(%{__python} -c "from distutils.sysconfig import get_python_lib; print get_python_lib(1)")}
%{!?ruby_sitearch: %global ruby_sitearch %(ruby -rrbconfig -e 'puts Config::CONFIG["sitearchdir"] ')}

%global codename DrO_o

Name:           xmms2
Summary:        A modular audio framework and plugin architecture
Version:        0.8
Release:        %mkrel 7
License:        LGPLv2+ and GPLv2+ and BSD
Group:          Sound/Players
# We can't use the upstream source tarball as-is, because it includes an mp4 decoder.
# http://downloads.sourceforge.net/xmms2/%%{name}-%%{version}%%{codename}.tar.bz2
# Cleaning it is simple, just rm -rf src/plugins/mp4
Source0:        %{name}-%{version}%{codename}-clean.tar.bz2
Source1:        xmms2-client-launcher.sh
# Use libdir properly for Fedora multilib
Patch1:         xmms2-0.8DrO_o-use-libdir.patch
# Set default output to pulse
Patch2:         xmms2-0.8DrO_o-pulse-output-default.patch
# Don't add extra CFLAGS, we're smart enough, thanks.
Patch4:         xmms2-0.8DrO_o-no-O0.patch
# More sane versioning
Patch5:         xmms2-0.8DrO_o-moresaneversioning.patch
URL:            http://wiki.xmms2.xmms.se/
BuildRequires:      sqlite3-devel, libflac-devel, libofa-devel
BuildRequires:      libcdio-devel, libdiscid-devel, libsmbclient-devel
BuildRequires:      libmpcdec-devel, gnome-vfs2-devel, libjack-devel
BuildRequires:      fftw-devel, libsamplerate-devel, libxml2-devel, alsa-lib-devel
BuildRequires:      libao-devel, libshout-devel, python-pyrex, ruby-devel, ruby
BuildRequires:      perl-devel, boost-devel, pulseaudio-devel, avahi-glib-devel
BuildRequires:      libmodplug-devel, ecore-devel, gamin-devel
BuildRequires:      avahi-compat-libdns_sd-devel
BuildRequires:      doxygen >= 1.6.7.1
BuildRequires:      libvisual-devel, libwavpack-devel, SDL-devel
BuildRequires:      glib2-devel, readline-devel, ncurses-devel

%description
XMMS2 is an audio framework, but it is not a general multimedia player - it 
will not play videos. It has a modular framework and plugin architecture for 
audio processing, visualization and output, but this framework has not been 
designed to support video. Also the client-server design of XMMS2 (and the 
daemon being independent of any graphics output) practically prevents direct 
video output being implemented. It has support for a wide range of audio 
formats, which is expandable via plugins. It includes a basic CLI interface 
to the XMMS2 framework, but most users will want to install a graphical XMMS2 
client (such as gxmms2 or esperanza).

%package devel
Summary:    Development libraries and headers for XMMS2
Group:      Development/C++
Requires:   glib2-devel, boost-devel
Requires:   %{name} = %{version}-%{release}

%description devel
Development libraries and headers for XMMS2. You probably need this to develop
or build new plugins for XMMS2.

%package docs
Summary:    Development documentation for XMMS2
Group:      Sound/Players
BuildArch:  noarch
Requires:   %{name} = %{version}-%{release}

%description docs
API documentation for the XMMS2 modular audio framework architecture.

%package python
Summary:    Python support for XMMS2
Group:      Sound/Players
Requires:   %{name} = %{version}-%{release}

%description python
Python bindings for XMMS2.

%package perl
Summary:    Perl support for XMMS2
License:    GPL+ or Artistic
Group:      Sound/Players
Requires:   %{name} = %{version}-%{release}

%description perl
Perl bindings for XMMS2.

%package ruby
Summary:    Ruby support for XMMS2
Group:      Sound/Players
Requires:   %{name} = %{version}-%{release}

%description ruby
Ruby bindings for XMMS2.

%package -n nyxmms2
Summary:    Commandline client for XMMS2
Group:      Sound/Players
Requires:   %{name} = %{version}-%{release}

%description -n nyxmms2
nyxmms2 is the new official commandline client for XMMS2. It can be run in
either shell-mode (if started without arguments), or in inline-mode where
it executes the command passed as argument directly.

%prep
%setup -q -n %{name}-%{version}%{codename}
%patch1 -p1 -b .plugins-use-libdir
%patch2 -p1 -b .default-output-pulse
%patch4 -p1 -b .noO0
%patch5 -p1 -b .versionsanity

# This header doesn't need to be executable
chmod -x src/include/xmmsclient/xmmsclient++/dict.h

# Clean up paths in wafadmin
# WAFADMIN_FILES=`find wafadmin/ -type f`
# for i in $WAFADMIN_FILES; do
#   sed -i 's|/usr/lib|%%{_libdir}|g' $i
# done
# sed -i 's|"lib"|"%%{_lib}"|g' wscript

%build
export CFLAGS="%{optflags}"
export CPPFLAGS="%{optflags}"
export LIBDIR="%{_libdir}"
export PYTHONDIR="%{python_sitearch}"
./waf configure --prefix=%{_prefix} --libdir=%{_libdir} --with-ruby-libdir=%{ruby_sitearch} --with-perl-archdir=%{perl_archlib} --with-pkgconfigdir=%{_libdir}/pkgconfig -j1
./waf build -v %{?_smp_mflags}
# make the docs
doxygen

%install
export LIBDIR="%{_libdir}"
export python_LIBDEST="%{python_sitearch}"
./waf install --destdir=%{buildroot} --prefix=%{_prefix} --libdir=%{_libdir} --with-ruby-libdir=%{ruby_sitearch} --with-perl-archdir=%{perl_archlib} --with-pkgconfigdir=%{_libdir}/pkgconfig

# exec flags for debuginfo
chmod +x %{buildroot}%{_libdir}/%{name}/* %{buildroot}%{_libdir}/libxmmsclient*.so* %{buildroot}%{python_sitearch}/xmmsclient/xmmsapi.so \
    %{buildroot}%{perl_archlib}/auto/Audio/XMMSClient/XMMSClient.so %{buildroot}%{ruby_sitearch}/xmmsclient_*.so

# Convert to utf-8
for i in %{buildroot}%{_mandir}/man1/*.gz; do
    gunzip $i;
done
for i in %{buildroot}%{_mandir}/man1/*.1 xmms2-0.8DrO_o.ChangeLog; do
    iconv -o $i.iso88591 -f iso88591 -t utf8 $i
    mv $i.iso88591 $i
done

install -m0755 %{SOURCE1} %{buildroot}%{_bindir}

%files
%doc AUTHORS xmms2-0.8DrO_o.ChangeLog COPYING COPYING.GPL COPYING.LGPL README TODO
%{_bindir}/%{name}*
%{_libdir}/libxmmsclient*.so.*
%{_libdir}/%{name}
%{_mandir}/man1/%{name}*
%{_datadir}/pixmaps/%{name}*
%{_datadir}/%{name}

%files devel
%{_includedir}/%{name}/
%{_libdir}/libxmmsclient*.so
%{_libdir}/pkgconfig/%{name}-*.pc

%files docs
%doc doc/xmms2/html

%files perl
%{perl_archlib}/Audio/
%{perl_archlib}/auto/Audio/

%files python
%{python_sitearch}/xmmsclient/

%files ruby
%{ruby_sitearch}/xmmsclient*

%files -n nyxmms2
%{_bindir}/nyxmms2


%changelog

* Wed Apr 10 2013 barjac <barjac> 0.8-7.mga3
+ Revision: 409450
- rebuild for boost-1.53

* Thu Jan 24 2013 juancho <juancho> 0.8-6.mga3
+ Revision: 391908
+ rebuild (emptylog)

* Mon Jan 14 2013 umeabot <umeabot> 0.8-5.mga3
+ Revision: 387219
- Mass Rebuild - https://wiki.mageia.org/en/Feature:Mageia3MassRebuild

* Fri Nov 02 2012 fwang <fwang> 0.8-4.mga3
+ Revision: 312331
- rebuild for new ruby

* Wed May 30 2012 jquelin <jquelin> 0.8-3.mga3
+ Revision: 251628
- perl 5.16 rebuild

* Mon Dec 19 2011 shlomif <shlomif> 0.8-2.mga2
+ Revision: 184490
- Convert to Mageia standard groups
- Change sqlite-devel BuildRequires to sqlite3-devel
- Convert the Release field to mkrel
- imported package xmms2


* Mon Dec  5 2011 Tom Callaway <spot@fedoraproject.org> - 0.8-1
- update to 0.8

* Sun Nov 20 2011 Adrian Reber <adrian@lisas.de> - 0.7-11
- Rebuild for libcdio-0.83

* Fri Jun 17 2011 Marcela Mašláňová <mmaslano@redhat.com> - 0.7-10
- Perl mass rebuild

* Thu Jun 09 2011 Marcela Mašláňová <mmaslano@redhat.com> - 0.7-9
- Perl 5.14 mass rebuild

* Mon Feb 07 2011 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.7-8
- Rebuilt for https://fedoraproject.org/wiki/Fedora_15_Mass_Rebuild

* Wed Nov 17 2010 Tom "spot" Callaway <tcallawa@redhat.com> - 0.7-7
- bump for libecore

* Thu Sep 02 2010 Rakesh Pandit <rakesh@fedoraproject.org> - 0.7-6
- Bump for libao

* Sat Jul 31 2010 Orcan Ogetbil <oget[dot]fedora[at]gmail[dot]com> - 0.7-5
- Add -j1 to the "./waf configure" line.

* Thu Jul 22 2010 David Malcolm <dmalcolm@redhat.com> - 0.7-4.1
- Rebuilt for https://fedoraproject.org/wiki/Features/Python_2.7/MassRebuild

* Tue Jun 29 2010 Mike McGrath <mmcgrath@redhat.com> - 0.7-3.1
- Rebuild to fix broken libcore-ver-svn dep

* Wed Jun 02 2010 Marcela Maslanova <mmaslano@redhat.com> - 0.7-3
- Mass rebuild with perl-5.12.0

* Tue Jun  1 2010 Ville Skyttä <ville.skytta@iki.fi> - 0.7-2
- Rebuild.

* Fri Jan 22 2010 Adrian Reber <adrian@lisas.de> - 0.6-7
- Rebuild for libcdio-0.82

* Tue Jan 19 2010 Tom "spot" Callaway <tcallawa@redhat.com> - 0.6-6
- rebuild for new boost

* Fri Dec  4 2009 Stepan Kasal <skasal@redhat.com> - 0.6-5
- rebuild against perl 5.10.1

* Fri Aug 21 2009 Tomas Mraz <tmraz@redhat.com> - 0.6-4
- rebuilt with new openssl

* Tue Aug 11 2009 Tom "spot" Callaway <tcallawa@redhat.com> - 0.6-3
- BuildRequires: glib2-devel, readline-devel, ncurses-devel

* Tue Aug 11 2009 Tom "spot" Callaway <tcallawa@redhat.com> - 0.6-2
- BuildRequires: SDL-devel

* Tue Aug 11 2009 Tom "spot" Callaway <tcallawa@redhat.com> - 0.6-1
- update to 0.6

* Mon Jul 27 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.5-7
- Rebuilt for https://fedoraproject.org/wiki/Fedora_12_Mass_Rebuild

* Thu Feb 26 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.5-6
- Rebuilt for https://fedoraproject.org/wiki/Fedora_11_Mass_Rebuild

* Sun Jan 18 2009 Tomas Mraz <tmraz@redhat.com> - 0.5-5
- rebuild with new openssl

* Tue Jan 13 2009 Adrian Reber <adrian@lisas.de> - 0.5-4
- Rebuild for libcdio-0.81

* Wed Dec 17 2008 Benjamin Kosnik  <bkoz@redhat.com> - 0.5-3
- Rebuild for boost-1.37.0.

* Wed Dec 10 2008 Tom "spot" Callaway <tcallawa@redhat.com> 0.5-2
- new docs subpackage
- many cleanups from package review

* Thu Dec 4 2008 Tom "spot" Callaway <tcallawa@redhat.com> 0.5-1
- Initial package for Fedora
